/*
 *
 * Copyright (C) 2000  Robert Olsson, Jens Ls 
 * Swedish University of Agricultural Sciences
 *
 * This file is part of GNU Zebra.
 *
 * GNU Zebra is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * GNU Zebra is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNU Zebra; see the file COPYING.  If not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  
 */

int query_thread(struct thread *t_query);
int other_querier_present(struct thread *t_other_querier_present);
int stop_query(struct pim_interface *pi);
int init_igmp(struct interface *ifp);
int local_in_addr(struct in_addr *src);
int Version_1_Router_Present(struct thread *t_Version_1_Router_Present);
void parse_igmp_query(struct in_addr *src, 
		      struct igmphdr *igmp,
		      struct interface *ifp);
int parse_igmp_report(struct in_addr *src,
		      struct igmphdr *igmp,
		      struct interface *ifp);
void init_igmp_timers(struct pim_interface *pi);
void parse_igmp_packet(char *p, int len, struct interface *ifp);
int igmp_read_raw(struct thread *r);
void igmp_query_neighbors(struct interface *ifp, 
			  u_int32_t group, 
			  u_int32_t dest,
			  u_int32_t interval);
void send_igmp_packet(struct interface *ifp,
		      char *buf, 
		      int len,
		      u_int32_t addr,
		      u_int32_t ip_opt);
void igmp_interface_init();
int igmp_if_start(struct interface *ifp);
int igmp_if_stop(struct interface *ifp);

struct oif *oif_alloc ();






