/*
 *
 * Copyright (C) 2000  Robert Olsson, Jens Ls 
 * Swedish University of Agricultural Sciences
 *
 * This file is part of GNU Zebra.
 *
 * GNU Zebra is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * GNU Zebra is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNU Zebra; see the file COPYING.  If not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.  
 */

char *inet_2a(u_int32_t a, char *b);

void parse_join_prune(struct in_addr *src,
		      char *ph, int len,
		      struct interface *ifp);
void parse_assert(struct in_addr *src,
		  char *ph,
		  int len,
		  struct interface *ifp);
void parse_register(struct in_addr *src,
		    char *ph,
		    int len,
		    struct interface *ifp);
void parse_register_stop(struct in_addr *src,
			 char *ph,
			 int len,
			 struct interface *ifp);
void parse_hello(struct in_addr *src,
		 char *ph,
		 int len,
		 struct interface *ifp);
int pim_neighbor_remove(struct pim_neighbor *pn);
int pim_all_neighbor_remove(struct interface *ifp);
struct pim_neighbor *pim_neighbor_new( struct in_addr *src,
				      int holdtime );
int pim_recvmsg (int sock,
		 u_char *buf,
		 int size,
		 int *ifindex);
int pim_read_raw(struct thread *r);

   

int decode_u_int16(char *p, u_int16_t *v);
int decode_u_int32(char *p, u_int32_t *v);
  
int decode_unicast(char *p, struct encoded_unicast *eu);
int encode_unicast(char *p, u_int32_t addr);
int decode_group(char *p, struct encoded_group *eg, int warning);
int encode_group(char *p, u_int32_t addr, u_int8_t masklen);
int decode_source(char *p, struct encoded_source *es);
int encode_source(char *p, u_int32_t addr, u_int8_t masklen, u_int8_t bits);

void oif_timer_update(struct mrt *mr, struct interface *ifp, u_int32_t newtime);
void update_mr_oif_timers(struct mrt *mr, struct interface *ifp, u_int16_t newtime);


